#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=icone.ico
#AutoIt3Wrapper_Outfile=LiveboxInfo.exe
#AutoIt3Wrapper_Outfile_x64=LiveboxInfo64.exe
#AutoIt3Wrapper_UseUpx=y
#AutoIt3Wrapper_Compile_Both=y
#AutoIt3Wrapper_UseX64=y
#AutoIt3Wrapper_Res_Description=Informations LiveBox Orange
#AutoIt3Wrapper_Res_Fileversion=1.9.5.0
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <ScreenCapture.au3>
#include <Date.au3>
#Region ### START Koda GUI section ### Form=
$Form1 = GUICreate("LiveBox info V1.9.5", 440, 500)

$hTab = GUICtrlCreateTab(10, 10, 420, 480)
; Create tabitems
GUICtrlCreateTabItem("WANstatus")
$Edit3 = GUICtrlCreateEdit("", 32, 40, 380, 377, $ES_WANTRETURN)
GUICtrlSetData(-1, "")
GUICtrlSetFont(-1, 10, 400, 0, "Courier New")

GUICtrlCreateTabItem("Deviceinfo")
$Edit4 = GUICtrlCreateEdit("", 32, 40, 380, 377, $ES_WANTRETURN)
GUICtrlSetData(-1, "")
GUICtrlSetFont(-1, 10, 400, 0, "Courier New")

GUICtrlCreateTabItem("Wifi")
$Edit5 = GUICtrlCreateEdit("", 32, 40, 380, 377)
GUICtrlSetData(-1, "")
GUICtrlSetFont(-1, 10, 400, 0, "Courier New")

; Close Tab definiton
GUICtrlCreateTabItem("")

$Button1 = GUICtrlCreateButton("Screenshot", 32, 424, 75, 25)
$Button2 = GUICtrlCreateButton("Copier dans presse papier", 32, 456, 147, 25)
$Button3 = GUICtrlCreateButton("Changer IP", 328, 424, 85, 25)
$Button4 = GUICtrlCreateButton("Reboot", 328, 456, 85, 25)
$Button5 = GUICtrlCreateButton("Refresh", 236, 424, 75, 25)
#EndRegion ### END Koda GUI section ###

Global $list1, $list2, $Edit1, $Edit2, $tab = 0
Global $iNowEpoch

$oHTTP = ObjCreate("winhttp.winhttprequest.5.1")

load_data()

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			; Logout
			$oHTTP.Open("POST", "http://" & $LIVEBOX & "/logout", False)
			$oHTTP.Send()
			$oHTTP = 0
			Exit

		Case $Button1 ; Screenshot
			$date = @YEAR & @MON & @MDAY
			$time = _NowTime()
			$time = StringReplace($time, ":", "")
			$datetime = $date & "_" & $time
			; Capture window
			_ScreenCapture_CaptureWnd(@ScriptDir & "/" & $datetime & "_infos_livebox.jpg", $Form1, 0, 0, -1, -1, False)

		Case $Button2 ; Copy TXT
			if $list1="" then
				$list = $list3_protege & @CRLF & "[---]" & @CRLF & $list4_protege
			Else
				$list = $list1 & @CRLF & "[---]" & @CRLF & $list2 & @CRLF & "[---]" & @CRLF & $list3_protege & @CRLF & "[---]" & @CRLF & $list4_protege
			EndIf
			ClipPut("[quote]" & $list & "[/quote]")
			MsgBox(0, "", "Le texte a été copié en mémoire, vous pouver coller le résultat sur le forum." & @CRLF & "Les informations confidentielles ont été masquées.")

		Case $Button3 ; Relancer connexion internet
			If $ProductClass[0] = "Livebox 3" Then
				$PARAMSreconnect1 = '{"parameters":{"name":"Enable","value":0,"flag":"ppp","traverse":"down"}}'
				$PARAMSreconnect2 = '{"parameters":{"name":"Enable","value":1,"flag":"ppp","traverse":"down"}}'
				$link1 = '/sysbus/NeMo/Intf/data:setFirstParameter'
				$link2 = '/sysbus/NeMo/Intf/data:setFirstParameter'

			ElseIf $ProductClass[0] = "Livebox FTTH v2" Then
				$PARAMSreconnect1 = '{"parameters":{"WanMode":"DSL_PPP"}}'
				$PARAMSreconnect2 = '{"parameters":{}}'
				$link1 = '/sysbus/NMC:setWanMode'
				$link2 = '/sysbus/NMC:getWANStatus'
			Else
				MsgBox(48, "ERREUR", "Type de livebox inconnue")
				ContinueCase
			EndIf

			auth_livebox()

			; Reconnect1
			$oHTTP.Open("POST", "http://" & $LIVEBOX & $link1, False)
			$oHTTP.SetRequestHeader("X-Context", $sContextID)
			$oHTTP.Send($PARAMSreconnect1)
			$oReceived = $oHTTP.ResponseText

			; Reconnect2
			$oHTTP.Open("POST", "http://" & $LIVEBOX & $link2, False)
			$oHTTP.SetRequestHeader("X-Context", $sContextID)
			$oHTTP.Send($PARAMSreconnect2)
			$oReceived = $oHTTP.ResponseText

			; Logout
			$oHTTP.Open("POST", "http://" & $LIVEBOX & "/logout", False)
			$oHTTP.Send()


		Case $Button4 ; Reboot Livebox
			$PARAMSreboot = '{"parameters":{}}'

			auth_livebox()

			; Reboot
			$oHTTP.Open("POST", "http://" & $LIVEBOX & "/sysbus/NMC:reboot", False)
			$oHTTP.SetRequestHeader("X-Context", $sContextID)
			$oHTTP.Send($PARAMSreboot)
			$oReceived = $oHTTP.ResponseText


			; Logout
			$oHTTP.Open("POST", "http://" & $LIVEBOX & "/logout", False)
			$oHTTP.Send()
			$oHTTP = 0


		Case $Button5 ; refresh

			load_data()


	EndSwitch
WEnd


Func load_data()
	; On vérifie que le fichier INI est bien présent
	$sFilePath = @ScriptDir & "\config.ini"
	$iFileExists = FileExists($sFilePath)
	If $iFileExists Then
		Global $LIVEBOX = IniRead(@ScriptDir & "\config.ini", "setting", "LiveboxIP", "192.168.1.1")
		Global $PASSWORD = IniRead(@ScriptDir & "\config.ini", "setting", "password", "")
	Else
		$Filepath = @ScriptDir & "\config.ini"
		FileOpen($Filepath, 1)
		FileWriteLine($Filepath, "[setting]")
		FileWriteLine($Filepath, "LiveboxIP=192.168.1.1")
		FileWriteLine($Filepath, "password=XXXXXXXX")
		MsgBox(48, "ERREUR", "Veuillez indiquer votre mot de passe Livebox dans le fichier CONFIG.INI")
		Exit
	EndIf

	; On vérifie que les étourdis ont bien mis leur mot de passe
	If ($PASSWORD = "" Or $PASSWORD = "XXXXXXXX") Then
		MsgBox(48, "ERREUR", "Veuillez indiquer votre mot de passe Livebox dans le fichier CONFIG.INI")
		Exit
	EndIf

	; On vérifie que la Livebox est bien sur l'IP indiquée et qu'elle répond - Merci à Arnaud pour avoir trouvé le Bug
   $ping = ping($LIVEBOX)
   if $ping = 0 then
		MsgBox(0,'Erreur de connexion',"La Livebox n'est pas joignable sur l'IP : " & $LIVEBOX)
		Exit
	EndIf

	Global $USER = "admin"
	$PARAMSgetDSLStats = '{"parameters":{}}'
	$PARAMSgetMIBs = '{"parameters":{"mibs":"dsl","flag":"","traverse":"down"}}'
	$PARAMSgetWANstatus = '{"parameters":{}}'
	$PARAMSgetWifi = '{"parameters":{"mibs":"wlanvap wlanradio base","flags":"wlanvap || wlanradio","traverse":"down"}}'

	auth_livebox()

	; Recuperation des donnees WANstatus
	$oHTTP.Open("POST", "http://" & $LIVEBOX & "/sysbus/NMC:getWANStatus", False)
	$oHTTP.SetRequestHeader("X-Context", $sContextID)
	$oHTTP.Send($PARAMSgetWANstatus)
	$getWANStatus = $oHTTP.ResponseText

	; Recuperation des donnees DeviceInfo
	$oHTTP.Open("GET", "http://" & $LIVEBOX & "/sysbus/DeviceInfo?_restDepth=-1", False)
	$oHTTP.SetRequestHeader("X-Context", $sContextID)
	$oHTTP.Send()
	$DeviceInfo = $oHTTP.ResponseText

	; Recuperation des donnees Wifi
	$oHTTP.Open("POST", "http://" & $LIVEBOX & "/sysbus/NeMo/Intf/lan:getMIBs", False)
	$oHTTP.SetRequestHeader("X-Context", $sContextID)
	$oHTTP.Send($PARAMSgetWifi)
	$getWifi = $oHTTP.ResponseText

	;Traitement getWANstatus
    $LinkType = StringRegExp($getWANStatus, 'LinkType":"(.*?)"', 3)
    $LinkState = StringRegExp($getWANStatus, 'LinkState":"(.*?)"', 3)
    $MACAddress = StringRegExp($getWANStatus, 'MACAddress":"(.*?)"', 3)
    $Protocol = StringRegExp($getWANStatus, 'Protocol":"(.*?)"', 3)
    $ConnectionState = StringRegExp($getWANStatus, 'ConnectionState":"(.*?)"', 3)
    $LastConnectionError = StringRegExp($getWANStatus, 'LastConnectionError":"(.*?)"', 3)
    $IPAddress = StringRegExp($getWANStatus, 'IPAddress":"(.*?)"', 3)
    $RemoteGateway = StringRegExp($getWANStatus, 'RemoteGateway":"(.*?)"', 3)
    $DNS = StringRegExp($getWANStatus, 'DNSServers":"(.*?)"', 3)
    $DNSServers = StringSplit($DNS[0], ",")
    $IPv6Address = StringRegExp($getWANStatus, 'IPv6Address":"(.*?)"', 3)

	Global $list3 = "LinkType            : " & $LinkType[0] & @CRLF & _
			"LinkState           : " & $LinkState[0] & @CRLF & _
			"MACAddress          : " & $MACAddress[0] & @CRLF & _
			"Protocol            : " & $Protocol[0] & @CRLF & _
			"ConnectionState     : " & $ConnectionState[0] & @CRLF & _
			"LastConnectionError : " & $LastConnectionError[0] & @CRLF & _
			"IPAddress           : " & $IPAddress[0] & @CRLF & _
			"RemoteGateway       : " & $RemoteGateway[0] & @CRLF & _
			"DNSServer1          : " & $DNSServers[1] & @CRLF & _
			"DNSServer2          : " & $DNSServers[2] & @CRLF & _
			"IPv6Address         : " & $IPv6Address[0]

	GUICtrlSetData($Edit3, $list3)

	$ip = StringSplit($IPAddress[0], ".")
	Global $list3_protege = "LinkType            : " & $LinkType[0] & @CRLF & _
			"LinkState           : " & $LinkState[0] & @CRLF & _
			"MACAddress          : " & StringLeft($MACAddress[0], 8) & ":xx:xx:xx" & @CRLF & _
			"Protocol            : " & $Protocol[0] & @CRLF & _
			"ConnectionState     : " & $ConnectionState[0] & @CRLF & _
			"LastConnectionError : " & $LastConnectionError[0] & @CRLF & _
			"IPAddress           : " & $ip[1] & "." & $ip[2] & ".xxx.xxx" & @CRLF & _
			"RemoteGateway       : " & $RemoteGateway[0] & @CRLF & _
			"DNSServer1          : " & $DNSServers[1] & @CRLF & _
			"DNSServer2          : " & $DNSServers[2] & @CRLF & _
			"IPv6Address         : " & $IPv6Address[0]

	;On vérifie si on est sur du DSL ou de la fibre car en fibre getDSLStats et getMIBs sont vides/inutiles
	if StringInStr ($LinkType[0],"dsl")>0 then

	; Recuperation des donnees DSLStats
	$oHTTP.Open("POST", "http://" & $LIVEBOX & "/sysbus/NeMo/Intf/dsl0:getDSLStats", False)
	$oHTTP.SetRequestHeader("X-Context", $sContextID)
	$oHTTP.Send($PARAMSgetDSLStats)
	$getDSLStats = $oHTTP.ResponseText

	; Recuperation des donnees MIBs
	$oHTTP.Open("POST", "http://" & $LIVEBOX & "/sysbus/NeMo/Intf/data:getMIBs", False)
	$oHTTP.SetRequestHeader("X-Context", $sContextID)
	$oHTTP.Send($PARAMSgetMIBs)
	$getMIBs = $oHTTP.ResponseText

	;Traitement getDSLStats
	$ReceiveBlocks = StringRegExp($getDSLStats, 'ReceiveBlocks":(.*?),"', 3)
	$TransmitBlocks = StringRegExp($getDSLStats, 'TransmitBlocks":(.*?),', 3)
	$CellDelin = StringRegExp($getDSLStats, 'CellDelin":(.*?),', 3)
	$LinkRetrain = StringRegExp($getDSLStats, 'LinkRetrain":(.*?),', 3)
	$InitErrors = StringRegExp($getDSLStats, 'InitErrors":(.*?),', 3)
	$InitTimeouts = StringRegExp($getDSLStats, 'InitTimeouts":(.*?),', 3)
	$LossOfFraming = StringRegExp($getDSLStats, 'LossOfFraming":(.*?),', 3)
	$ErroredSecs = StringRegExp($getDSLStats, 'ErroredSecs":(.*?),', 3)
	$SeverelyErroredSecs = StringRegExp($getDSLStats, 'SeverelyErroredSecs":(.*?),', 3)
	$FECErrors = StringRegExp($getDSLStats, 'FECErrors":(.*?),', 3)
	$ATUCFECErrors = StringRegExp($getDSLStats, 'ATUCFECErrors":(.*?),', 3)
	$HECErrors = StringRegExp($getDSLStats, 'HECErrors":(.*?),', 3)
	$ATUCHECErrors = StringRegExp($getDSLStats, 'ATUCHECErrors":(.*?),', 3)
	$CRCErrors = StringRegExp($getDSLStats, 'CRCErrors":(.*?),', 3)
	$ATUCCRCErrors = StringRegExp($getDSLStats, 'ATUCCRCErrors":(.*?)}}', 3)

	Global $list1 = "ReceiveBlocks        : " & $ReceiveBlocks[0] & @CRLF & _
			"TransmitBlocks       : " & $TransmitBlocks[0] & @CRLF & _
			"CellDelin            : " & $CellDelin[0] & @CRLF & _
			"LinkRetrain          : " & $LinkRetrain[0] & @CRLF & _
			"InitErrors           : " & $InitErrors[0] & @CRLF & _
			"InitTimeouts         : " & $InitTimeouts[0] & @CRLF & _
			"LossOfFraming        : " & $LossOfFraming[0] & @CRLF & _
			"ErroredSecs          : " & $ErroredSecs[0] & @CRLF & _
			"SeverelyErroredSecs  : " & $SeverelyErroredSecs[0] & @CRLF & _
			"FECErrors            : " & $FECErrors[0] & @CRLF & _
			"ATUCFECErrors        : " & $ATUCFECErrors[0] & @CRLF & _
			"HECErrors            : " & $HECErrors[0] & @CRLF & _
			"ATUCHECErrors        : " & $ATUCHECErrors[0] & @CRLF & _
			"CRCErrors            : " & $CRCErrors[0] & @CRLF & _
			"ATUCCRCErrors        : " & $ATUCCRCErrors[0]


	;Traitement getMIBs
	$LastChangeTime = StringRegExp($getMIBs, 'LastChangeTime":(.*?),', 3)
	$LastChange = StringRegExp($getMIBs, 'LastChange":(.*?),', 3)
	$LinkStatus = StringRegExp($getMIBs, 'LinkStatus":"(.*?)"', 3)
	$UpstreamCurrRate = StringRegExp($getMIBs, 'UpstreamCurrRate":(.*?),', 3)
	$DownstreamCurrRate = StringRegExp($getMIBs, 'DownstreamCurrRate":(.*?),', 3)
	$UpstreamMaxRate = StringRegExp($getMIBs, 'UpstreamMaxRate":(.*?),', 3)
	$DownstreamMaxRate = StringRegExp($getMIBs, 'DownstreamMaxRate":(.*?),', 3)
	$UpstreamNoiseMargin = StringRegExp($getMIBs, 'UpstreamNoiseMargin":(.*?),', 3)
	$DownstreamNoiseMargin = StringRegExp($getMIBs, 'DownstreamNoiseMargin":(.*?),', 3)
	$UpstreamAttenuation = StringRegExp($getMIBs, 'UpstreamAttenuation":(.*?),', 3)
	$DownstreamAttenuation = StringRegExp($getMIBs, 'DownstreamAttenuation":(.*?),', 3)
	$UpstreamPower = StringRegExp($getMIBs, 'UpstreamPower":(.*?),', 3)
	$DownstreamPower = StringRegExp($getMIBs, 'DownstreamPower":(.*?),', 3)
	$DataPath = StringRegExp($getMIBs, 'DataPath":"(.*?)"', 3)
	$InterleaveDepth = StringRegExp($getMIBs, 'InterleaveDepth":(.*?),', 3)
	$ModulationType = StringRegExp($getMIBs, 'ModulationType":"(.*?)"', 3)
	$ModulationHint = StringRegExp($getMIBs, 'ModulationHint":"(.*?)"', 3)
	$FirmwareVersion = StringRegExp($getMIBs, 'FirmwareVersion":"(.*?)"', 3)
	$StandardUsed = StringRegExp($getMIBs, 'StandardUsed":"(.*?)"', 3)
	$CurrentProfile = StringRegExp($getMIBs, 'CurrentProfile":"(.*?)","UPBOKLE', 3)
	$UPBOKLE = StringRegExp($getMIBs, 'UPBOKLE":(.*?)}', 3)

	Global $list2 = "LastChangeTime       : " & $LastChangeTime[0] & @CRLF & _
			"LastChange           : " & $LastChange[0] & @CRLF & _
			"LinkStatus           : " & $LinkStatus[0] & @CRLF & _
			"UpstreamCurrRate     : " & $UpstreamCurrRate[0] & " Kb/s" & @CRLF & _
			"DownstreamCurrRate   : " & $DownstreamCurrRate[0] & " Kb/s" & @CRLF & _
			"UpstreamMaxRate      : " & $UpstreamMaxRate[0] & " Kb/s" & @CRLF & _
			"DownstreamMaxRate    : " & $DownstreamMaxRate[0] & " Kb/s" & @CRLF & _
			"UpstreamNoiseMargin  : " & $UpstreamNoiseMargin[0] / 10 & " dB" & @CRLF & _
			"DownstreamNoiseMargin: " & $DownstreamNoiseMargin[0] / 10 & " dB" & @CRLF & _
			"UpstreamAttenuation  : " & $UpstreamAttenuation[0] / 10 & " dB" & @CRLF & _
			"DownstreamAttenuation: " & $DownstreamAttenuation[0] / 10 & " dB" & @CRLF & _
			"UpstreamPower        : " & $UpstreamPower[0] & @CRLF & _
			"DownstreamPower      : " & $DownstreamPower[0] & @CRLF & _
			"DataPath             : " & $DataPath[0] & @CRLF & _
			"InterleaveDepth      : " & $InterleaveDepth[0] & @CRLF & _
			"ModulationType       : " & $ModulationType[0] & @CRLF & _
			"ModulationHint       : " & $ModulationHint[0] & @CRLF & _
			"FirmwareVersion      : " & $FirmwareVersion[0] & @CRLF & _
			"StandardUsed         : " & $StandardUsed[0] & @CRLF & _
			"CurrentProfile       : " & $CurrentProfile[0] & @CRLF & _
			"UPBOKLE              : " & $UPBOKLE[0]

	if $tab = 0 then ; on créé les onglets qu'une seule fois sinon a chaque refresh ils sont recréés.
		; Create tabitems
		GUICtrlCreateTabItem("DSLstats")
		$Edit1 = GUICtrlCreateEdit("", 32, 40, 380, 377, $ES_WANTRETURN)
		GUICtrlSetData(-1, "")
		GUICtrlSetFont(-1, 10, 400, 0, "Courier New")
		GUICtrlCreateTabItem("MIBS")
		$Edit2 = GUICtrlCreateEdit("", 32, 40, 380, 377, $ES_WANTRETURN)
		GUICtrlSetData(-1, "")
		GUICtrlSetFont(-1, 10, 400, 0, "Courier New")
		$tab = 1
	endif

	; Affichage des données
	GUICtrlSetData($Edit1, $list1)
	GUICtrlSetData($Edit2, $list2)

	EndIf

	;Traitement DeviceInfo
	$Manufacturer = StringRegExp($DeviceInfo, 'Manufacturer","type":"string","attributes":\{"read_only": true\},"state":"ready","value":"(.*?)"', 3)
	$ManufacturerOUI = StringRegExp($DeviceInfo, 'ManufacturerOUI","type":"string","attributes":{"read_only": true},"state":"ready","value":"(.*?)"', 3)
	$ModelName = StringRegExp($DeviceInfo, 'ModelName","type":"string","attributes":{"read_only": true},"state":"ready","value":"(.*?)"', 3)
	$Description = StringRegExp($DeviceInfo, 'Description","type":"string","attributes":{"read_only": true},"state":"ready","value":"(.*?)"', 3)
	Global $ProductClass = StringRegExp($DeviceInfo, 'ProductClass","type":"string","attributes":{"read_only": true},"state":"ready","value":"(.*?)"', 3)
	$SerialNumber = StringRegExp($DeviceInfo, 'SerialNumber","type":"string","attributes":{"read_only": true},"state":"ready","value":"(.*?)"', 3)
	$HardwareVersion = StringRegExp($DeviceInfo, 'HardwareVersion","type":"string","attributes":{"read_only": true},"state":"ready","value":"(.*?)"', 3)
	$SoftwareVersion = StringRegExp($DeviceInfo, 'SoftwareVersion","type":"string","attributes":{"read_only": true},"state":"ready","value":"(.*?)"', 3)
	$RescueVersion = StringRegExp($DeviceInfo, 'RescueVersion","type":"string","attributes":{"read_only": true},"state":"ready","value":"(.*?)"', 3)
	$ModemFirmwareVersion = StringRegExp($DeviceInfo, 'ModemFirmwareVersion","type":"string","attributes":{"read_only": true},"state":"ready","value":"(.*?)"', 3)
	$EnabledOptions = StringRegExp($DeviceInfo, 'EnabledOptions","type":"string","attributes":{"read_only": true},"state":"ready","value":"(.*?)"', 3)
	$AdditionalHardwareVersion = StringRegExp($DeviceInfo, 'AdditionalHardwareVersion","type":"string","attributes":{"read_only": true},"state":"ready","value":"(.*?)"', 3)
	$AdditionalSoftwareVersion = StringRegExp($DeviceInfo, 'AdditionalSoftwareVersion","type":"string","attributes":{"read_only": true},"state":"ready","value":"(.*?)"', 3)
	$SpecVersion = StringRegExp($DeviceInfo, 'SpecVersion","type":"string","attributes":{"read_only": true},"state":"ready","value":"(.*?)"', 3)
	$ProvisioningCode = StringRegExp($DeviceInfo, 'ProvisioningCode","type":"string","attributes":{"persistent": true},"state":"ready","value":"(.*?)"', 3)
	$UpTime = StringRegExp($DeviceInfo, 'UpTime","type":"uint32","attributes":{"read_only": true},"state":"ready","value":(.*?)}', 3)
	$ManufacturerURL = StringRegExp($DeviceInfo, 'ManufacturerURL","type":"string","attributes":{"read_only": true},"state":"ready","value":"(.*?)"', 3)
	$Country = StringRegExp($DeviceInfo, 'Country","type":"string","attributes":{"read_only": true},"state":"ready","value":"(.*?)"', 3)
	$NumberOfReboots = StringRegExp($DeviceInfo, 'NumberOfReboots","type":"uint32","attributes":{"read_only": true,"persistent": true},"state":"ready","value":(.*?)}', 3)
	If IsArray($NumberOfReboots) Then
		$NumberOfReboots = $NumberOfReboots[0]
	Else
		$NumberOfReboots = "N/A"
	EndIf

	$iNowEpoch = _DateDiff('s', "1970/01/01 00:00:00", _NowCalc())
	$sUptimeEpoch = $iNowEpoch - $Uptime[0]
	$sUpDate = _DateAdd('s', $sUptimeEpoch, "1970/01/01 00:00:00")

	Global $list4 = "Manufacturer     : " & $Manufacturer[0] & @CRLF & _
			"ManufacturerOUI  : " & $ManufacturerOUI[0] & @CRLF & _
			"ModelName        : " & $ModelName[0] & @CRLF & _
			"ProductClass     : " & $ProductClass[0] & @CRLF & _
			"SerialNumber     : " & $SerialNumber[0] & @CRLF & _
			"HardwareVersion  : " & $HardwareVersion[0] & @CRLF & _
			"SoftwareVersion  : " & $SoftwareVersion[0] & @CRLF & _
			"HardwareVersion 2: " & $AdditionalHardwareVersion[0] & @CRLF & _
			"SoftwareVersion 2: " & $AdditionalSoftwareVersion[0] & @CRLF & _
			"RescueVersion    : " & $RescueVersion[0] & @CRLF & _
			"EnabledOptions   : " & $EnabledOptions[0] & @CRLF & _
			"SpecVersion      : " & $SpecVersion[0] & @CRLF & _
			"ProvisioningCode : " & $ProvisioningCode[0] & @CRLF & _
			"UpTime           : " & $Uptime[0] & @CRLF & _
			"                 : " & $sUpDate & @CRLF & _
			"                 : " & _temps_passe($Uptime[0]*1000) & @CRLF & _
			"Country          : " & $Country[0] & @CRLF & _
			"NumberOfReboots  : " & $NumberOfReboots

	GUICtrlSetData($Edit4, $list4)
	$SerialNumber = StringLeft($SerialNumber[0], 8)
	Global $list4_protege = "Manufacturer     : " & $Manufacturer[0] & @CRLF & _
			"ManufacturerOUI  : " & $ManufacturerOUI[0] & @CRLF & _
			"ModelName        : " & $ModelName[0] & @CRLF & _
			"ProductClass     : " & $ProductClass[0] & @CRLF & _
			"SerialNumber     : " & $SerialNumber & "XXXXXXX" & @CRLF & _
			"HardwareVersion  : " & $HardwareVersion[0] & @CRLF & _
			"SoftwareVersion  : " & $SoftwareVersion[0] & @CRLF & _
			"HardwareVersion 2: " & $AdditionalHardwareVersion[0] & @CRLF & _
			"SoftwareVersion 2: " & $AdditionalSoftwareVersion[0] & @CRLF & _
			"RescueVersion    : " & $RescueVersion[0] & @CRLF & _
			"EnabledOptions   : " & $EnabledOptions[0] & @CRLF & _
			"SpecVersion      : " & $SpecVersion[0] & @CRLF & _
			"UpTime           : " & $Uptime[0] & @CRLF & _
			"                 : " & $sUpDate & @CRLF & _
			"                 : " & _temps_passe($Uptime[0]*1000) & @CRLF & _
			"Country          : " & $Country[0] & @CRLF & _
			"NumberOfReboots  : " & $NumberOfReboots


	;Traitement getWifi
	Local $MacList1, $MacList2, $list5ghz
	$SSID = StringRegExp($getWifi, '"SSID":"(.*?)","', 3)
	$SSIDAdvertisementEnabled = StringRegExp($getWifi, 'SSIDAdvertisementEnabled":(.*?),"', 3)
	$BSSID = StringRegExp($getWifi, '"BSSID":"(.*?)","', 3)
	$WEPKey = StringRegExp($getWifi, 'WEPKey":"(.*?)","', 3)
	$PreSharedKey = StringRegExp($getWifi, 'PreSharedKey":"(.*?)","', 3)
	$KeyPassPhrase = StringRegExp($getWifi, 'KeyPassPhrase":"(.*?)","', 3)
	$SelfPIN = StringRegExp($getWifi, 'SelfPIN":"(.*?)","', 3)
	$SupportedFrequencyBands = StringRegExp($getWifi, 'SupportedFrequencyBands":"(.*?)","', 3)
	$Channel = StringRegExp($getWifi, '"Channel":(.*?),"AutoChannelSupported', 3)
	$ModeEnabled = StringRegExp($getWifi, 'ModeEnabled":"(.*?)","', 3)
	$MACFiltering = StringRegExp($getWifi, 'MACFiltering":{"Mode":"(.*?)","', 3)
	If IsArray($MACFiltering) Then
		If $MACFiltering[0] = "WhiteList" Then
			$Entry = StringRegExp($getWifi, 'Entry(.*?)HotSpot2', 3)
			If IsArray($Entry) Then
				$MACAddress = StringRegExp($Entry[0], 'MACAddress":"(.*?)"', 3)
				For $i = 0 To UBound($MACAddress) - 1
					$MacList1 = $MacList1 & @CRLF & "                " & $MACAddress[$i]
				Next
			EndIf
		Else
			$MacList1 = ""
		EndIf
		$MACFiltering1 = $MACFiltering[0]
	Else
		$MACFiltering1 = "non trouvé"
	EndIf

	;Vérification des variables array
	If IsArray($SSID) Then
		$SSID1 = $SSID[0]
	Else
		$SSID1 = "non trouvé"
	EndIf
	If IsArray($SSIDAdvertisementEnabled) Then
		$SSIDAdvertisementEnabled1 = $SSIDAdvertisementEnabled[0]
	Else
		$SSIDAdvertisementEnabled1 = "non trouvé"
	EndIf
	If IsArray($BSSID) Then
		$BSSID1 = $BSSID[0]
	Else
		$BSSID1 = "non trouvé"
	EndIf
	If IsArray($WEPKey) Then
		$WEPKey1 = $WEPKey[0]
	Else
		$WEPKey1 = "non trouvé"
	EndIf
	If IsArray($PreSharedKey) Then
		$PreSharedKey1 = $PreSharedKey[0]
	Else
		$PreSharedKey1 = "non trouvé"
	EndIf
	If IsArray($KeyPassPhrase) Then
		$KeyPassPhrase1 = $KeyPassPhrase[0]
	Else
		$KeyPassPhrase1 = "non trouvé"
	EndIf
	If IsArray($SelfPIN) Then
		$SelfPIN1 = $SelfPIN[0]
	Else
		$SelfPIN1 = "non trouvé"
	EndIf
	If IsArray($SupportedFrequencyBands) Then
		$SupportedFrequencyBands1 = $SupportedFrequencyBands[0]
	Else
		$SupportedFrequencyBands1 = "non trouvé"
	EndIf
	If IsArray($Channel) Then
		$Channel1 = $Channel[0]
	Else
		$Channel1 = "non trouvé"
	EndIf
	If IsArray($ModeEnabled) Then
		$ModeEnabled1 = $ModeEnabled[0]
		$ModeEnabled1 = StringReplace($ModeEnabled1, "None", "No security")
        $ModeEnabled1 = StringReplace($ModeEnabled1, "WPA-WPA2", "WPA/WPA2 Mixed")
        $ModeEnabled1 = StringReplace($ModeEnabled1, "WPA2-", "WPA2-PSK(AES)-")
        $ModeEnabled1 = StringReplace($ModeEnabled1, "WPA-", "WPA-PSK(TKIP)-")
	Else
		$ModeEnabled1 = "non trouvé"
	EndIf


	$list24ghz = "2,4Ghz" & @CRLF & _
			"SSID          : " & $SSID1 & @CRLF & _
			"SSID Visible  : " & $SSIDAdvertisementEnabled1 & @CRLF & _
			"BSSID         : " & $BSSID1 & @CRLF & _
			"WEPKey        : " & $WEPKey1 & @CRLF & _
			"PreSharedKey  : " & $PreSharedKey1 & @CRLF & _
			"KeyPassPhrase : " & $KeyPassPhrase1 & @CRLF & _
			"SelfPIN       : " & $SelfPIN1 & @CRLF & _
			"SupportedBands: " & $SupportedFrequencyBands1 & @CRLF & _
			"Channel       : " & $Channel1 & @CRLF & _
			"ModeEnabled   : " & StringReplace($ModeEnabled1, "-Personal", " Personnel") & @CRLF & _
			"MACFiltering  : " & $MACFiltering1 & $MacList1

	If UBound($SSID) > 1 Then

		If IsArray($MACFiltering) Then
			If $MACFiltering[1] = "WhiteList" Then
				$Entry = StringRegExp($getWifi, 'Entry(.*?)HotSpot2', 3)
				If IsArray($Entry) Then
					$MACAddress = StringRegExp($Entry[1], 'MACAddress":"(.*?)"', 3)
					For $i = 0 To UBound($MACAddress) - 1
						$MacList2 = $MacList2 & @CRLF & "                " & $MACAddress[$i]
					Next
				EndIf
			Else
				$MacList2 = ""
			EndIf
			$MACFiltering2 = $MACFiltering[1]
		Else
			$MACFiltering2 = "non trouvé"
		EndIf

		If IsArray($ModeEnabled) Then
			$ModeEnabled2 = $ModeEnabled[1]
			$ModeEnabled2 = StringReplace($ModeEnabled2, "None", "No security")
			$ModeEnabled2 = StringReplace($ModeEnabled2, "WPA-WPA2", "WPA/WPA2 Mixed")
			$ModeEnabled2 = StringReplace($ModeEnabled2, "WPA2-", "WPA2-PSK(AES)-")
			$ModeEnabled2 = StringReplace($ModeEnabled2, "WPA-", "WPA-PSK(TKIP)-")
		Else
			$ModeEnabled2 = "non trouvé"
		EndIf


		$list5ghz = "5,0Ghz" & @CRLF & _
				"SSID          : " & $SSID[1] & @CRLF & _
				"SSID Visible  : " & $SSIDAdvertisementEnabled[1] & @CRLF & _
				"BSSID         : " & $BSSID[1] & @CRLF & _
				"WEPKey        : " & $WEPKey[1] & @CRLF & _
				"PreSharedKey  : " & $PreSharedKey[1] & @CRLF & _
				"KeyPassPhrase : " & $KeyPassPhrase[1] & @CRLF & _
				"SelfPIN       : " & $SelfPIN[1] & @CRLF & _
				"SupportedBands: " & $SupportedFrequencyBands[1] & @CRLF & _
				"Channel       : " & $Channel[1] & @CRLF & _
				"ModeEnabled   : " & StringReplace($ModeEnabled2, "-Personal", " Personnel") & @CRLF & _
				"MACFiltering  : " & $MACFiltering[1] & $MacList2
	EndIf
	Global $list5 = $list24ghz & @CRLF & @CRLF & $list5ghz

	GUICtrlSetData($Edit5, $list5)

	;on affiche l'interface
	GUISetState(@SW_SHOW)

EndFunc   ;==>load_data

Func auth_livebox()
	$str = "/authenticate?username=" & $USER & "&password=" & $PASSWORD
	$oHTTP.Open("POST", "http://" & $LIVEBOX & $str, False)
	$oHTTP.SetRequestHeader("Content-Type", "application/json")
	$oHTTP.Send()
	$oReceived = $oHTTP.ResponseText
	Global $sContextID = StringRegExp($oReceived, 'contextID":"([^"]+)"|()$', 1)[0]
	If $sContextID == "" Then
		MsgBox(48, "ERREUR", "Mot de passe LiveBox incorrect, veuillez vérifier le fichier config.ini")
		Exit
	EndIf
EndFunc   ;==>auth_livebox

Func _temps_passe($miliseconds)
    $miliseconds
    $day = Int($miliseconds / 86400000)
    $hour = Int(Mod($miliseconds, 86400000) / 3600000)
    $min = Int(Mod(Mod($miliseconds, 86400000), 3600000) / 60000)
    $sec = Int(Mod(Mod(Mod($miliseconds, 86400000), 3600000), 60000) / 1000)
    $time = $day & " Jour(s) " & $hour &"h " & $min & "m " & $sec & "s"
	return $time
EndFunc   ;==>_temps_passe